"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCCodeGenerator subclass:#PPCTokenizingCodeGenerator
	instanceVariableNames:'tokenGenerator'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Visitors'
!

!PPCTokenizingCodeGenerator methodsFor:'accessing'!

guards
    "When tokenizing, do not use guards"
    ^ false
!

tokenGenerator
    ^ tokenGenerator isNil 
        ifTrue: [ tokenGenerator := (PPCTokenCodeGenerator on: compiler)
            arguments: arguments;
            yourself ]
        ifFalse: [ tokenGenerator ]
!

tokenGenerator: whatever
    tokenGenerator := whatever
! !

!PPCTokenizingCodeGenerator methodsFor:'visiting'!

visitChoiceNode: node
"       true ifTrue: [ ^ super visitChoiceNode: node ]."
    "HACK alert: We are inside token..."

    (node firstSetWithTokens contains: [ :e | e isTokenNode not ]) ifTrue: [ ^ super visitChoiceNode: node ].
         
    node children do: [ :child |
        | tokenMethodName |
        
        child firstSetWithTokens do: [ :first |
            "For each child, for each first compile this:"
            tokenMethodName := compiler idFor: first.
            compiler add: '(self currentTokenTypeIs: ', tokenMethodName storeString, ')'.
            compiler addOnLine: ' ifTrue: ['.
            compiler indent.
            compiler codeStoreValueOf: [ self visit: child ] intoVariable: self retvalVar.
            compiler add: 'error ifFalse: ['.
            compiler indent.
            compiler codeReturn: self retvalVar.
            compiler dedent.
            compiler add: '] ifTrue: ['.
            compiler indent.
            compiler codeClearError.
            compiler codeAssign: 'nil.' to: 'currentTokenType'.
            compiler add: 'context position: currentTokenValue start - 1.'.
            compiler dedent.
            compiler add: ']'.
            compiler dedent.
            compiler add: '].'
        ]
    ].

    compiler codeError: 'no choice found'.

    "Modified: / 10-05-2015 / 07:37:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

visitDeterministicChoiceNode: node
    | dictionary |
    dictionary := IdentityDictionary new.
    
    node children do: [ :child |
        | firstSet |
        firstSet := child firstSetWithTokens.
        self assert: firstSet size = 1.
        dictionary at: child 
            put: firstSet anyOne.
            
    ].
    "Tokens are unique"
    self assert: dictionary values asSet size = node children size.
    
"	currentTokenVar := compiler allocateTemporaryVariableNamed: 'currentToken'.
    compiler codeAssign: 'self currentTokenType.' to: currentTokenVar.
"	node children do: [ :child |
        | tokenMethodName |
        tokenMethodName := compiler idFor: (dictionary at: child).
        compiler add: '(self currentTokenTypeIs: ', tokenMethodName storeString, ')'.
        compiler addOnLine: ' ifTrue: ['.
        compiler indent.
        compiler codeStoreValueOf: [ self visit: child ] intoVariable: self retvalVar.
        compiler codeReturn: self retvalVar.
        compiler dedent.
        compiler add: '].'
    ].

    compiler codeError: 'no choice found'.
!

visitTokenChoiceNode: node
    | trimmingToken |
    self assert: (node children allSatisfy: [ :e | e isMarkedForInline not ]).
    
    node children do: [ :child |
        self tokenGenerator visit: child
    ]
    
"	
    trimmingToken := node children detect: [ :e | e isTrimmingTokenNode ] ifNone: [ nil ].
    trimmingToken isNil ifFalse: [ 
        compiler codeStoreValueOf: [ self visit: trimmingToken whitespace ] intoVariable: #whatever.
    ].
    super visitChoiceNode: node."
!

visitTokenConsumeNode: node
    compiler codeReturn: 'self consume: ', (compiler idFor: node child) storeString, '.'
!

visitTokenNode: node
    self error: 'shoudl not happend!!'
!

visitTokenizingParserNode: node
    self visit: node tokenizer.
    self visit: node whitespace.
    
"	compiler codeNextToken."
    compiler codeHaltIfShiftPressed.
    compiler codeStoreValueOf: [ self visit: node parser ] intoVariable: self retvalVar.
    compiler codeReturn.
!

visitTrimmingTokenNode: node
    self error: 'shoudl not happend!!'
! !

